<template>

    <div class="d-flex flex-column  border border-light shadow-lg rounded my-5 p-5 bg-white">
        <h1 class="font-weight-bold"> Blog Details {{form.id === 0 ? ' - New' : ' - '+ this.title }}</h1>

        <form id="blogForm" @submit.prevent="saveBlog" @keydown="form.onKeydown($event)">
            <div class="form-group">
                <label for="title">Title</label>
                <input v-model="form.title" type="text" id="title" name="title" class="form-control" placeholder="Title">
            </div>

            <div class="form-group">
                <label for="description">Description</label>
                <vue-editor v-model="form.description" id="description" placeholder="Description"/>
            </div>

            <div class="form-group">
                <image-picker id="image" label="Picture" @getFile="getBrowsePic" :value="imageSrc"/>
            </div>

            <div class="d-flex justify-content-end align-items-center mt-5">
                <button type="button" class="btn btn-danger mr-2" @click="backToHome">
                    <fa icon="times-circle"/> Cancel
                </button>
                <v-button :loading="form.busy">
                    <fa icon="save"/> Save
                </v-button>
            </div>
        </form>

    </div>


</template>

<script>
    import {VueEditor} from "vue2-editor";
    import Card from "../components/Card";
    import ImagePicker from "../components/ImagePicker";
    import VButton from "../components/Button";
    import Form from 'vform';

    export default {
        name: "BlogEntry",
        middleware: 'auth',
        metaInfo () {
            return { title: 'Blog Entry' }
        },
        components: {VButton, ImagePicker, Card, VueEditor},
        data(){
            return {
                form: new Form({
                    id:0,
                    title: '',
                    description: '',
                }),
                title:'',
                pictureData:null,
                imageSrc:''
            }
        },
        async beforeRouteEnter(to,from,next){
            next(vm =>  vm.getDetails(to.params.id))
        },
        async beforeRouteUpdate(to, from, next){
            await this.getDetails(to.params.id);
            next();
        },
        methods: {
            backToHome() {
                this.$router.push({name: 'home'})
            },
            getBrowsePic(e){
                this.pictureData = e;
            },
            async getDetails(blogId){
                await axios.post('/api/blog',{id:blogId}).then(response =>{
                    if(response.data.success){
                        this.title = response.data.result.title;
                        this.form.id = response.data.result.id;
                        this.form.title = response.data.result.title;
                        this.form.description = response.data.result.description;
                        this.imageSrc = response.data.result.image;
                    }
                })
            },
            async saveBlog(){
                let formData = this.getFormData();
                formData.append('picture',this.pictureData);

                await axios.post('/api/saveBlog', formData).then(response =>{
                    if(response.data.success){
                        this.$toast.success(response.data.message);
                    }else{
                        this.$toast.error(response.data.message);
                    }
                })

            },
            getFormData(){
                let formData = new FormData();

                for (let key in this.form.data()) {
                    if(this.$moment.isDate(this.form[key]))
                        formData.append(key, moment(this.form[key]).format('YYYY-MM-DD'));
                    else if(this.form[key] === 'null')
                        formData.append(key, '');
                    else
                        formData.append(key, this.form[key]);
                }
                return formData;
            }
        }
    }
</script>

<style scoped>

</style>